#include <xc.h>

#include "LTlib.h"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "MCP2300x.h"
#include "MCP2300x.c"
/*
#include "PCF8574.h"
#include "PCF8574.c"*/

#include "LCD_44780_I2C.h"
#include "LCD_44780_I2C.c"




//*************************************
//     Prototipo di funzione
//*************************************
void board_initialization (void);


//*************************************
//     Programma principale
//*************************************
int main (void){

    unsigned char frase [] = "Hello World 2";

    board_initialization ();

    // Inizializzo il display LCD con quarzo a 20MHz
    LCD_initialize (20);

    LCD_backlight (LCD_TURN_ON_LED);

    LCD_write_message ("Hello World 1");

    LCD_goto_line (2);

    LCD_write_string (frase);
    
    // Ciclo infinito
    while (1) {

    }
}


//*************************************
//     Implementazione della funzione
//*************************************
void board_initialization (void) {
    
    // Imposto PORTA tutti ingressi
    LATA = 0x00;
    ANSELA = 0x00;
    TRISA = 0xFF;

    // Imposto PORTB tutti ingressi
    LATB = 0x00;
    ANSELB = 0x00;
    TRISB = 0xFF;

    // Imposto PORTC tutti ingressi, RC1 come output
    LATC = 0x00;
    ANSELC = 0x00;
    TRISC = 0b11111101;

    // Imposto PORTD tutte uscite, RD0 come ingresso
    LATD = 0x00;
    ANSELD = 0x00;
    TRISD = 0b00000001;

    // Imposto PORTE tutti ingressi
    LATE = 0x00;
    ANSELE = 0x00;
    TRISE = 0xFF;
}
